#!/bin/bash
# Script para generar un grafo de dependencias
# ============================================
# El encabezado
echo 'digraph Cross_Reference { concentrate=true' > $2
# Donde esta la tabla en el mapa
sed '1,/Cross Reference Table/d' $1 |
# Eliminamos las primeras 2 lineas que no sirven
sed '1,2d' |
# Formateamos el grafo
awk '{  if ($2 != "") {
            print "\n"$2" -> {" 
        } else { 
            print $1
        }
     }' ORS=' ' |
# Agregamos un } al final de cada linea
sed '2,$s/$/\}/' |
# Sacamos la extension .o
sed 's/\.o//g' |
# Acortamos los nombres
sed 's/[[:alnum:]]*\/[[:alnum:]]*\///g' | 
# Sacamos la tabla de simbolos
sed '/^build\/symbol_table/d' |
sed 's/build\/symbol_table//g' | 
# Sacamos utils
sed '/^utils/d' |
sed 's/utils//g' |
# Sacamos exception
sed '/^exception/d' |
sed 's/exception//g' |
# Sacamos kernel
sed '/^kernel/d' |
sed 's/kernel//g' |
# Sacamos repetidos y guardamos en archivo
sort | uniq >> $2
# La llave que cierra
echo "}" >> $2
# Creamos el grafico
dot -v -Tpng $2 > graph.png
