#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#include <types.h>

typedef struct symbol_entry {
    uintptr_t addr;
    char* name;
} symbol_entry;

symbol_entry* get_symbol_entry(uintptr_t fun_addr);
void calltrace(uint64_t count);
void kernel_panic(const char* function, 
                  const uint64_t line, 
                  const char* file, 
                  const char* message, ...);

#define KERNEL_PANIC(...) \
    kernel_panic(__FUNCTION__, __LINE__, __FILE__, __VA_ARGS__);

#define PANIC_IF(c) \
	if(c) { KERNEL_PANIC("[PANIC_IF] " #c); }

#define PANIC_UNLESS(c) \
    if(!(c)) { KERNEL_PANIC("[PANIC_UNLESS] " #c); }

#endif  /* !__EXCEPTION_H__*/
