#ifndef __IOAPIC_H__
#define __IOAPIC_H__

#include <types.h>

// Direccion default donde esta mepado el IOAPIC
#define DEFAULT_IOAPIC_ADDR             0xFEC00000

#define IOAPIC_ID_INDEX                 0
#define IOAPIC_VERSION_INDEX            1
#define IOAPIC_ARBITRATION_INDEX        2
#define IOAPIC_REDIRECTION_TABLE_INDEX  16

#define IOAPIC_RD_MASK_BIT              0x10000

#define IOAPIC_RD_DELIVERY_NORMAL       0x000
#define IOAPIC_RD_DELIVERY_LOW          0x100
#define IOAPIC_RD_DELIVERY_SYSTEM       0x200
#define IOAPIC_RD_DELIVERY_NONMASKABLE  0x400
#define IOAPIC_RD_DELIVERY_INIT         0x500
#define IOAPIC_RD_DELIVERY_EXTERNAL     0x700

void initialize_ioapic(uint32_t ioapic, uint8_t bsp_id);

#endif
