#include <defines.h>
#include <gdt.h>

gdt_entry gdt[GDT_COUNT] = {
        /* NULL Descriptor */
        [GDT_INDEX_NULL] = {.limit_0_15 = 0x0000,
                            .base_0_15 = 0x0000,
                            .base_23_16 = 0x00,
                            .type = 0x00,
                            .s = 0x00,
                            .dpl = 0x00,
                            .p = 0x00,
                            .limit_16_19 = 0x00,
                            .avl = 0x00,
                            .l = 0x00,
                            .db = 0x00,
                            .g = 0x00,
                            .base_31_24 = 0x00},
        /* Type: 32 bit Code execute only   (type: 1000b, s: 1, l: 0, db: 1)
         * Base: 0x0                        (base: 0x0)
         * Limit: 0xFFFFFFFF                (limit: 0xFFFFF, g: 1)
         * Descriptor Privilege Level: 0    (dpl: 0)
         * Present: Yes                     (p: 1)
         */
        [GDT_INDEX_CODE_DPL0_32] = {.limit_0_15 = 0xFFFF,
                                    .base_0_15 = 0x0000,
                                    .base_23_16 = 0x00,
                                    .type = 0x08,
                                    .s = 0x01,
                                    .dpl = 0x00,
                                    .p = 0x01,
                                    .limit_16_19 = 0x0F,
                                    .avl = 0x00,
                                    .l = 0x00,
                                    .db = 0x01,
                                    .g = 0x01,
                                    .base_31_24 = 0x00},
        /* Type: Data read/write            (type: 0010b, s: 1, l: 0, db: 1)
         * Base: 0x0                        (base: 0x0)
         * Limit: 0xFFFFFFFF                (limit: 0xFFFFF, g: 1)
         * Descriptor Privilege Level: 0    (dpl: 0)
         * Present: Yes                     (p: 1)
         */
        [GDT_INDEX_DATA_DPL0] = {.limit_0_15 = 0xFFFF,
                                 .base_0_15 = 0x0000,
                                 .base_23_16 = 0x00,
                                 .type = 0x02,
                                 .s = 0x01,
                                 .dpl = 0x00,
                                 .p = 0x01,
                                 .limit_16_19 = 0x0F,
                                 .avl = 0x00,
                                 .l = 0x00,
                                 .db = 0x01,
                                 .g = 0x01,
                                 .base_31_24 = 0x00},
        /* Type: 64 bit Code execute only   (type: 1000b, s: 1, l: 1, db: 0)
         * Base: 0x0                        (base: 0x0)
         * Limit: 0xFFFFFFFF                (limit: 0xFFFFF, g: 1)
         * Descriptor Privilege Level: 0    (dpl: 0)
         * Present: Yes                     (p: 1)
         */
        [GDT_INDEX_CODE_DPL0_64] = {.limit_0_15 = 0xFFFF,
                                    .base_0_15 = 0x0000,
                                    .base_23_16 = 0x00,
                                    .type = 0x08,
                                    .s = 0x01,
                                    .dpl = 0x00,
                                    .p = 0x01,
                                    .limit_16_19 = 0x0F,
                                    .avl = 0x00,
                                    .l = 0x01,
                                    .db = 0x00,
                                    .g = 0x01,
                                    .base_31_24 = 0x00}};

gdt_descriptor GDT_DESC = {.gdt_length = sizeof(gdt) - 1,
                           .gdt_addr = (uint64_t)&gdt};
