#include <print.h>
#include <screen.h>
#include <utils.h>

int print(const char* msg) {
    while (*msg)
        screen_putchar(*msg++);
    return 0;
}

int vprintf(const char* msg, va_list l) {
    char buffer[72];
    // Este buffer alcanza para cualquier input posible:
    // Se necesitan 64 digitos para un numero binario de 64 bits,
    // y menos que eso para cualquier base mayor
    for (uint64_t i = 0; msg[i]; i++) {
        if (msg[i] != '%') {
            screen_putchar(msg[i]);
            continue;
        }
        i++;
        switch (msg[i]) {
            case '%':
                screen_putchar(msg[i]);
                break;
            case 'X':
            case 'x':
            case 'p':  // Enteros sin signo en hexadecimal
                itoa_log(va_arg(l, uint64_t), buffer, 4);
                print(buffer);
                break;
            case 'u':  // Enteros sin signo en decimal
            case 'd':  // Enteros con signo en decimal
            case 'i':
                itoa(va_arg(l, int64_t), buffer);
                print(buffer);
                break;
            case 's':  // String
                print(va_arg(l, char*));
                break;
            case 'c':  // Char
                screen_putchar(va_arg(l, uint64_t));
                break;
            case 'b':  // Booleano
                print(va_arg(l, uint64_t) ? "true" : "false");
                break;
            case 'o':  // Octal
                itoa_log(va_arg(l, uint64_t), buffer, 3);
                print(buffer);
        }
    }
    return 0;
}

int printf(const char* msg, ...) {
    va_list l;
    va_start(l, msg);
    vprintf(msg, l);
    va_end(l);
    return 0;
}
