#ifndef __EXT2_WORKBENCH
#define __EXT2_WORKBENCH

#include <types.h>
#include <assert.h>

#define MIN(a,b) (((a)<(b))?(a):(b))
#define ATA_SECTSIZE    512L

void write_test(void);
void dir_test(void);
void error_test(void);
void truncate_test(void);

void* kmalloc(uint64_t size);
void kfree(void* data);
void print_fs_data();
void extract_file(char *source_path, char* dest_path);
void hdd_read(uint32_t lba_address, uint32_t sectors, void* buffer);
void hdd_write(uint32_t lba_address, uint32_t sectors, void* buffer);
uint64_t scrn_read(void *buffer, uint64_t count);
uint64_t scrn_write(void *buffer, uint64_t count);
uint64_t scrn_write_err(void *buffer, uint64_t count);

void kernel_panic(const char* function, 
                  const uint64_t line, 
                  const char* file, 
                  const char* message, ...);
#endif 
