#ifndef __IO_CLASH_H__
#define __IO_CLASH_H__

#include <stdint.h>

int64_t     io_init();
int64_t     io_kill();
uint64_t    sys_read(int64_t fd, void *buf, uint64_t count);
uint64_t    sys_write(int64_t fd, void *buf, uint64_t count);
int64_t     sys_seek(int64_t fd, int64_t offset, int64_t origin);
int64_t     sys_tell(int64_t fd);
uint8_t     sys_type(const char *path);
int64_t     sys_create(const char *path, uint8_t type);
int64_t     sys_remove(const char *path); 
int64_t     sys_truncate(int64_t fd, uint64_t length);
int64_t     sys_open(const char *path);
int64_t     sys_close(int64_t fd);
int64_t     sys_opendir(const char *path);
int64_t     sys_closedir(int64_t dd);
int64_t     sys_rewinddir(int64_t dd);
/* Devuelve un puntero al siguiente filename. 
 * NULL si llegó al final de la lista. */
dir_entry * sys_readdir(int64_t dd);

#endif
